//+------------------------------------------------------------------+
//|                                                         Sell.mq4 |
//|                      Copyright  2012, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
#define TimeOpenOrder 30000        // -           
bool WriteLog=false;         // -  true,              
bool ErrorAlert=false;      // -  true,        .
bool PrintLog=false;               

int timestart=0;
extern int PeriodMA=12;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
string Symbol_="";

int handle=0;
int init()
{
   Symbol_=Symbol();
    if(WriteLog)
    {
       int t=TimeCurrent();
       string FileName=StringConcatenate(WindowExpertName(),"_",TimeYear(t),"_",TimeMonth(t),"_",TimeDay(t),"/",TimeHour(t),"_",TimeMinute(t),"Log_to_","_",Symbol_,"_",Period(),".log");
       int result;
       handle=FileOpen (FileName,FILE_CSV|FILE_WRITE);
       if(handle<0) 
       {
         Print("   ",FileName); 
         return(0);
       }
    }
   return(0);
}
//+------------------------------------------------------------------+
//|                                            |
//+------------------------------------------------------------------+
int deinit()
{
//----
   if(WriteLog)
   {
      if(handle>0)FileClose(handle);
   }
//----
   return(0);
}//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   if(Bid<iMA(NULL,0,PeriodMA,0,MODE_EMA,PRICE_OPEN,0)&&timestart<TimeCurrent()-60)
   {
      
      timestart=TimeCurrent();
      OpenOrders(Symbol(),OP_BUYLIMIT,Bid,0.01,0,0,0,0,"", "",true);   
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+
int OpenOrders(string Symb, int cmd,double OpenPrice,double lot,int slip,double SL,double TP,int MG,string PP,string coment,bool OpenStops=false)
{
   RefreshRates();
   string stroka="";
   if(MarketInfo(Symb,MODE_BID)==0)
   {
      stroka=" : "+Symb;Alert(stroka);
      WriteFile(stroka);
      return(-1);
   }
   double Point_=MarketInfo(Symb,MODE_POINT);
   double StopLevel=MarketInfo(Symb,MODE_STOPLEVEL);
   stroka=GetTickCount()+"   \r\n"+TimeToStr(TimeCurrent(),TIME_DATE|TIME_MINUTES|TIME_SECONDS)+"\r\n";
   stroka=stroka+"   :"+"\r\n";
   stroka=stroka+": "+ Symb+", \r\n: "+ cmd+", \r\n ="+OpenPrice+ ", \r\n: "+ lot+", : "+MG+"\r\n";
   stroka=stroka+"StopLoss="+SL+", \r\nTakeProfit="+TP+"\r\n";
   double PriceSL;
   double PriceTP;
   int ticket=-1;
   lot=NL(Symb,lot);
   int err=0;
   if (SL<StopLevel&&SL!=0)
   {
      SL=StopLevel+1;
      stroka=stroka+" StopLoss    : "+ SL+"\r\n";
      stroka=stroka+" StopLoss   ."+"\r\n";
      if(ErrorAlert)
      {
         Alert(" StopLoss    : ", SL);
         Alert(" StopLoss   .");
      }
   }
   if (TP<StopLevel&&TP!=0)
   {
      TP=StopLevel+1;
      stroka=stroka+" TakeProfit    : "+ TP+"\r\n";
      stroka=stroka+" TakeProfit   ."+"\r\n";
      if(ErrorAlert)
      {
         Alert(" TakeProfit    : ", TP);
         Alert(" TakeProfit   .");
      }
   }
   if(lot<MarketInfo(Symb,MODE_MINLOT)||lot>MarketInfo(Symb,MODE_MAXLOT))
   {
      stroka=stroka+"   !"+"\r\n";if(ErrorAlert)Alert("   !");return(-1);
   }
   WriteFile(stroka);stroka="";
   if(FreeEquity(Symb,lot)==(-1))
   {
      //WriteFile(stroka);
      return(-1);
   }
   if(trueDeal()!=0)
   {
      //WriteFile(stroka);
      return(-1);
   }
   int StartSend=GetTickCount();
   //while(ticket<0)
   {
      if(GetTickCount()-StartSend>TimeOpenOrder)
      {
         stroka=stroka+"-        "+"\r\n";if(ErrorAlert)Alert("-        ");return(-1);
      }
      RefreshRates();
      double Ask_=n1(Symb,MarketInfo(Symb,MODE_ASK)),Bid_=n1(Symb,MarketInfo(Symb,MODE_BID));
      if (cmd==OP_SELL)
      {
         TP=TP*(-1);
         if (SL>0||SL<0)PriceSL=n1(Symb,Bid_+SL*Point_);else PriceSL=0;
         if (TP>0||TP<0)PriceTP=n1(Symb,Bid_+TP*Point_);else PriceTP=0;
         if(OpenStops)
         {
            ticket=OrderSend(Symb,cmd,lot,Bid_,slip,PriceSL,PriceTP,coment,MG);err=GetLastError();
            err=GetLastError();
            if(ticket>=0)
            {
               stroka=stroka+"SELL "+ticket+"\r\n";
               WriteFile(stroka);return(ticket);
            }
         } else {ticket=OrderSend(Symb,cmd,lot,Bid_,slip,0,0,coment,MG);err=GetLastError();}
         stroka=stroka+"SELL "+ticket+"\r\n";
      }
      if (cmd==OP_BUY)
      {
         SL=SL*(-1);
         if (SL>0||SL<0)PriceSL=n1(Symb,Ask_+SL*Point_); else PriceSL=0;
         if (TP>0||TP<0)PriceTP=n1(Symb,Ask_+TP*Point_); else PriceTP=0;
         if(OpenStops)
         {
            ticket=OrderSend(Symb,cmd,lot,Ask_,slip,PriceSL,PriceTP,coment,MG);err=GetLastError();
            err=GetLastError();
            if(ticket>=0)
            {
               stroka=stroka+"BUY "+ticket+"\r\n";
               WriteFile(stroka);
               return(ticket);
            }
         } else {ticket=OrderSend(Symb,cmd,lot,Ask_,slip,0,0,coment,MG);err=GetLastError();}
         stroka=stroka+"BUY "+ticket+"\r\n";
      }
      if (cmd==OP_BUYLIMIT)
      {
         if((Ask_-OpenPrice)/Point_<StopLevel)
         {
            stroka=stroka+"       ."+"\r\n";
            stroka=stroka+"  ,      ,    : "+MarketInfo(Symb,MODE_STOPLEVEL)+1+" ."+"\r\n";
            if(ErrorAlert)Alert(stroka);
            WriteFile(stroka);
            return(-1);
         }
         SL=SL*(-1);
         if (SL>0||SL<0)PriceSL=n1(Symb,OpenPrice+SL*Point_); else PriceSL=0;
         if (TP>0||TP<0)PriceTP=n1(Symb,OpenPrice+TP*Point_); else PriceTP=0;
         if(OpenStops)
         {
            ticket=OrderSend(Symb,cmd,lot,OpenPrice,slip,PriceSL,PriceTP,coment,MG);err=GetLastError();
            err=GetLastError();
            if(ticket>=0)
            {
               stroka=stroka+"BUYLIMIT "+ticket+"\r\n";
               WriteFile(stroka);
               return(ticket);
            }
         } else {ticket=OrderSend(Symb,cmd,lot,OpenPrice,slip,0,0,coment,MG);err=GetLastError();}
         stroka=stroka+"BUYLIMIT "+ticket+"\r\n";
      }
      if (cmd==OP_BUYSTOP)
      {
         if((OpenPrice-Ask_)/Point_<StopLevel)
         {
            stroka=stroka+"       ."+"\r\n";
            stroka=stroka+"  ,      ,    : "+MarketInfo(Symb,MODE_STOPLEVEL)+1+" ."+"\r\n";
            if(ErrorAlert)Alert(stroka);
            WriteFile(stroka);
            return(-1);
         }
         SL=SL*(-1);
         if (SL>0||SL<0)PriceSL=n1(Symb,OpenPrice+SL*Point_); else PriceSL=0;
         if (TP>0||TP<0)PriceTP=n1(Symb,OpenPrice+TP*Point_); else PriceTP=0;
         if(OpenStops)
         {
            ticket=OrderSend(Symb,cmd,lot,OpenPrice,slip,PriceSL,PriceTP,coment,MG);err=GetLastError();
            err=GetLastError();
            if(ticket>=0)
            {
               stroka=stroka+"BUYSTOP "+ticket+"\r\n";
               WriteFile(stroka);
               return(ticket);
            }
         } else {ticket=OrderSend(Symb,cmd,lot,OpenPrice,slip,0,0,coment,MG);err=GetLastError();}
         stroka=stroka+"BUYSTOP "+ticket+"\r\n";
      }
      if (cmd==OP_SELLLIMIT)
      {
         if((OpenPrice-Bid_)/Point_<StopLevel)
         {
            stroka=stroka+"       ."+"\r\n";
            stroka=stroka+"  ,      ,    : "+MarketInfo(Symb,MODE_STOPLEVEL)+1+" ."+"\r\n";
            if(ErrorAlert)Alert(stroka);
            WriteFile(stroka);
            return(-1);
         }
         TP=TP*(-1);
         if (SL>0||SL<0)PriceSL=n1(Symb,OpenPrice+SL*Point_); else PriceSL=0;
         if (TP>0||TP<0)PriceTP=n1(Symb,OpenPrice+TP*Point_); else PriceTP=0;
         if(OpenStops)
         {
            ticket=OrderSend(Symb,cmd,lot,OpenPrice,slip,PriceSL,PriceTP,coment,MG);err=GetLastError();
            err=GetLastError();
            if(ticket>=0)
            {
               stroka=stroka+"SELLLIMIT "+ticket+"\r\n";
               WriteFile(stroka);
               return(ticket);
            }
         } else {ticket=OrderSend(Symb,cmd,lot,OpenPrice,slip,0,0,coment,MG);err=GetLastError();}
         stroka=stroka+"SELLLIMIT "+ticket+"\r\n";
      }
      if (cmd==OP_SELLSTOP)
      {
         if((Bid_-OpenPrice)/Point_<StopLevel)
         {
            stroka=stroka+"       ."+"\r\n";
            stroka=stroka+"  ,      ,    : "+MarketInfo(Symb,MODE_STOPLEVEL)+1+" ."+"\r\n";
            if(ErrorAlert)Alert(stroka);
            WriteFile(stroka);
            return(-1);
         }
         TP=TP*(-1);
         if (SL>0||SL<0)PriceSL=n1(Symb,OpenPrice+SL*Point_); else PriceSL=0;
         if (TP>0||TP<0)PriceTP=n1(Symb,OpenPrice+TP*Point_); else PriceTP=0;
         if(OpenStops)
         {
            ticket=OrderSend(Symb,cmd,lot,OpenPrice,slip,PriceSL,PriceTP,coment,MG);err=GetLastError();
            err=GetLastError();
            if(ticket>=0)
            {
               stroka=stroka+"SELLSTOP "+ticket+"\r\n";
               WriteFile(stroka);
               return(ticket);
            }
         } else {ticket=OrderSend(Symb,cmd,lot,OpenPrice,slip,0,0,coment,MG);err=GetLastError();}
         stroka=stroka+"SELLSTOP "+ticket+"\r\n";
      }
      if (ticket<0)
      {
         stroka=stroka+"   #"+err+" "+PP+"\r\n";
      } else 
      {
         if(TP==0&&SL==0)
         {
            WriteFile(stroka);
            return(ticket);
         }
         RefreshRates();
         while(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)==false)
         {
            if(GetTickCount()-StartSend>TimeOpenOrder)
            {
               stroka=stroka+"   !"+"\r\n";if(ErrorAlert)Alert("   !");
               WriteFile(stroka);
               return(-1);
            }
            Sleep(1);
         }
         if (PriceTP==OrderTakeProfit()&&PriceSL==OrderStopLoss()) 
         {
            WriteFile(stroka);
            return(ticket);
         }
         else 
         {
            if (OrderModify(OrderTicket(),OrderOpenPrice(),PriceSL,PriceTP,0)==false)
            {
               stroka=stroka+"    StopLoss  TakeProfit    : "+MarketInfo(Symb,MODE_STOPLEVEL)+"\r\n";
               if(ErrorAlert)Alert("    StopLoss  TakeProfit    : ",MarketInfo(Symb,MODE_STOPLEVEL));
               stroka=stroka+"   #"+GetLastError()+" "+PP+" Price="+OrderOpenPrice()+" SL="+PriceSL+" TP="+PriceTP+"\r\n";
               if(ErrorAlert)Alert("   #",GetLastError()," ",PP," Price=",OrderOpenPrice()," SL=",PriceSL," TP=",PriceTP);
            }
         }
      }
      Sleep(100);
   }
   WriteFile(stroka);
return(ticket);
}
int FreeEquity(string Symb,double lot)
{
   int res=0;
   string stroka=TimeToStr(TimeCurrent(),TIME_DATE|TIME_MINUTES|TIME_SECONDS)+"\r\n";
   if(MarketInfo(Symb,MODE_MARGINREQUIRED)*lot<AccountFreeMargin())
   {
      stroka=stroka+"      "+ lot+ ": "+MarketInfo(Symb,MODE_MARGINREQUIRED)*lot+",  : "+AccountEquity()+"\r\n";
   }
   else 
   {
      stroka=stroka+"--------------------------------"+"\r\n";if(ErrorAlert)Alert("--------------------------------");
      stroka=stroka+"      : "+lot+"\r\n";if(ErrorAlert)Alert("      : ",lot);
      res=(-1);
   }
   WriteFile(stroka);
   return(res);
}
double n1(string sym,double v)
{
   return(NormalizeDouble(v,MarketInfo(sym,MODE_DIGITS)));
}
double NL (string Sym,double lots) {
   double step=MarketInfo(Sym,MODE_LOTSTEP);
   return (MathRound(lots/step)*step);
}
int trueDeal()
{
   string stroka=TimeToStr(TimeCurrent(),TIME_DATE|TIME_MINUTES|TIME_SECONDS)+"\r\n";
   if(!IsTradeAllowed())
   {
      stroka=stroka+"--------------------------------"+"\r\n";if(ErrorAlert)Alert("--------------------------------");
      stroka=stroka+"  !    !"+"\r\n";if(ErrorAlert)Alert("  !   !");
      WriteFile(stroka);
      return(-1);
   }
   if(IsTradeContextBusy())
   {
      stroka=stroka+"--------------------------------"+"\r\n";if(ErrorAlert)Alert("--------------------------------");
      stroka=stroka+"  !"+"\r\n";if(ErrorAlert)Alert("  !");
      WriteFile(stroka);
      return(-1);
   }
   if(!IsConnected()&&!IsTesting())
   {
      stroka=stroka+"--------------------------------"+"\r\n";if(ErrorAlert)Alert("--------------------------------");
      stroka=stroka+"    ,     ."+"\r\n";if(ErrorAlert)Alert("    ,     .");
      stroka=stroka+"     !"+"\r\n";if(ErrorAlert)Alert("     !");
      WriteFile(stroka);
      return(-1);
   }
   return(0);
}
void WriteFile(string stroka)
{
   if(PrintLog)Print(stroka);
   if(handle>0)
   {
      if(WriteLog)FileWrite(handle,stroka);
   }
   return;
}